<template>
  <v-main class="mainStyle">
    <v-card>
      <h2>Nachrichten</h2>
    </v-card>

    <v-card
        @click.stop="showMessage = !showMessage"
        class="mt-3"
        v-for="user in users"
    >{{user.userId}} {{user.username}}
    <v-card
        v-show="message.receiverId === user.userId && showMessage"
        v-for="message in messagesReceived"
    >{{user.username}}: {{message.messageContent}}</v-card>
      <v-card
          v-show="message.senderId === user.userId && showMessage"
          v-for="message in messagesSent"
      >{{authStore.user.username}}: {{message.messageContent}}</v-card>
      <v-form
          @submit.prevent="createMessage">
        <v-text-field
            v-model="messageToPost.messageContent"
        >
        </v-text-field>
        <v-btn type="submit">Senden</v-btn>
      </v-form>
    </v-card>

<!--    <employee-data
        v-for="user in users"
        :user="user"
        :page="currentPage"
    ></employee-data>-->


<!--    <v-card
        class="mt-2"
        v-for="message in messagesSent"
    ><p>{{ message.senderId}}</p>{{message.messageContent}}</v-card>
    <v-card
        class="bg-blue-darken-4 mt-2"
        v-for="message in messagesReceived"
    ><p>{{message.senderId}}</p>{{message.messageContent}}</v-card>

    <v-form @submit.prevent="createMessage">
      <v-text-field
          v-model="messageToPost.messageContent"
      >
      </v-text-field>
      <v-btn type="submit">Senden</v-btn>
    </v-form>-->

  </v-main>

</template>

<script setup>
import {computed, onMounted, ref} from "vue";
import {useMessagesStore} from "@/stores/messagesStore";
import {useUserStore} from "@/stores/userStore";
import EmployeeData from "@/components/EmployeeData.vue";
import {useAuthStore} from "@/stores/authStore";
import {router} from "@/router";

const messageStore = useMessagesStore();
const userStore = useUserStore();
const authStore = useAuthStore();
const users = computed(() => userStore.users)
const messagesReceived = computed(() => messageStore.messagesReceived)
const messagesSent = computed(() => messageStore.messagesSent)
const senderId = 555;
const receiverId = 556;
const showMessage = ref(false)
const messageToPost = ref({
  messageContent: "",
  senderId: authStore.user.userId
});
const currentPage = ref(1);

async function fetchUsers() {
  await userStore.getAllUsers();
}

async function createMessage() {
  await messageStore.postMessage(556, messageToPost.value);
  await messageStore.getMessagesReceived(receiverId, senderId);
  await messageStore.getMessagesSent(senderId, receiverId);
  messageToPost.value.messageContent = "";
}

onMounted(async () => {
  await messageStore.getMessagesReceived(receiverId, senderId);
  await messageStore.getMessagesSent(senderId, receiverId);
  await fetchUsers();
})
</script>

<style scoped>
.mainStyle{
  min-height: 100vh;
}

</style>